(define (domain intrusion-detection)
	(:requirements :strips :typing)
	(:types host)
	(:predicates
		(recon-performed ?h - host)
		(broke-into ?h - host)
		(deleted-logs ?h - host)
		(modified-files ?h - host)
		(access-obtained ?h - host)
		(root-access-obtained ?h - host)
		(files-downloaded ?h - host)
		(information-gathered ?h - host)
		(vandalized ?h - host)
		(data-stolen-from ?h - host)
		(dummy)
	)
	(:action recon
		:parameters (?h - host)
		:precondition (and (dummy))
		:effect (and (recon-performed ?h))
	)
	(:action information-gathering
		:parameters (?h - host)
		:precondition (and (recon-performed ?h))
		:effect (and (information-gathered ?h))
	)
	(:action break-into
		:parameters (?h - host)
		:precondition (and (recon-performed ?h))
		:effect (and (access-obtained ?h))
	)
	(:action modify-files
		:parameters (?h - host)
		:precondition (and (access-obtained ?h))
		:effect (and (modified-files ?h))
	)
	(:action clean
		:parameters (?h - host)
		:precondition (and (access-obtained ?h))
		:effect (and (deleted-logs ?h))
	)
	(:action vandalize
		:parameters (?h - host)
		:precondition (and (modified-files ?h) (deleted-logs ?h))
		:effect (and (vandalized ?h))
	)
	(:action gain-root
		:parameters (?h - host)
		:precondition (and (access-obtained ?h))
		:effect (and (root-access-obtained ?h))
	)
	(:action download-files
		:parameters (?h - host)
		:precondition (and (root-access-obtained ?h))
		:effect (and (files-downloaded ?h))
	)
	(:action steal-data
		:parameters (?h - host)
		:precondition (and (files-downloaded ?h) (deleted-logs ?h))
		:effect (and (data-stolen-from ?h))
	)
)
